/*
 *  Demo of COSS Relationship Service
 *  Copyright (C) 1998 Karel Gardas
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 *  or to my private e-mail:
 *                 gardask@alpha.inf.upol.cz
 */


#include <mico/Role_impl.h>
#include <mico/Relationship_impl.h>
#include "Employment.h"


#ifndef __Employment_impl_h__
#define __Employment_impl_h__


class EmployerRole_impl : virtual public Role_impl,
		       virtual public Employment::EmployerRole_skel
{
public:
  EmployerRole_impl ();
  EmployerRole_impl (CORBA::Object_ptr obj);
  EmployerRole_impl (CosRelationships::RelatedObject_ptr, CORBA::Long);

};


class EmployeeRole_impl : virtual public Role_impl,
			  virtual public Employment::EmployeeRole_skel
{
public:
  EmployeeRole_impl ();
  EmployeeRole_impl (CORBA::Object_ptr obj);
  EmployeeRole_impl (CosRelationships::RelatedObject_ptr, CORBA::Long);

};


class Employment_impl : virtual public Relationship_impl,
			virtual public Employment::Relationship_skel
{
  Employment::Date tsince;
  Employment::Date tto;
public:    
  Employment_impl ();
  
  Employment_impl (CORBA::Object_ptr obj);
  Employment_impl (CosRelationships::NamedRoles nr);

  virtual CORBA::Boolean _save_object ();
  virtual Employment::Date since ();
  virtual void since (const Employment::Date& value);
  virtual Employment::Date to ();
  virtual void to (const Employment::Date& value);
};


class EmployerRoleLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


class EmployeeRoleLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


class EmploymentLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


#endif

