/*
 *  Demo of COSS Relationship Service
 *  Copyright (C) 1998 Karel Gardas
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 *  or to my private e-mail:
 *                 gardask@alpha.inf.upol.cz
 */


#include <iostream.h>
#include <fstream.h>
#include <unistd.h>
#include "Documents.h"
#include "Documents_impl.h"

//#define DEBUG 0

int main( int argc, char *argv[] )
{
    FigureLoader loader;
    CORBA::ORB_var orb = CORBA::ORB_init( argc, argv, "mico-local-orb" );
    CORBA::BOA_var boa = orb->BOA_init (argc, argv, "mico-local-boa");

    if (!boa->restoring()) {
#if DEBUG
      cout << "  <FigureServer> Creating FigureFactory\n" << endl;
#endif
      Documents::FigureFactory* pf = new FigureFactory_impl;
      boa->obj_is_ready (pf, 0);
#if DEBUG
      cout << "  <FigureServer> orb->run ();\n";
#endif
    } 
    else {
#if DEBUG
      cout << "  <FigureServer> Restoring Figure:\n";
#endif
      boa->obj_is_ready (0, 0);
#if DEBUG
      cout << "  <FigureServer> orb->run ();\n";
#endif
    }

    orb->run ();
#if DEBUG
    cout << "  <FigureServer> END!\n";
#endif
    return 0;
}





