/*
 *  Demo of COSS Relationship Service
 *  Copyright (C) 1998 Karel Gardas
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 *  or to my private e-mail:
 *                 gardask@alpha.inf.upol.cz
 */


#include <mico/Role_impl.h>
#include <mico/Relationship_impl.h>
#include "Reference.h"


#ifndef __Reference_impl_h__
#define __Reference_impl_h__


class ReferencesRole_impl : virtual public Role_impl,
			    virtual public Reference::ReferencesRole_skel
{
public:
  ReferencesRole_impl ();
  ReferencesRole_impl (CORBA::Object_ptr obj);
  ReferencesRole_impl (CosRelationships::RelatedObject_ptr, CORBA::Long);

};


class ReferencedByRole_impl : virtual public Role_impl,
			      virtual public Reference::ReferencedByRole_skel
{
public:
  ReferencedByRole_impl ();
  ReferencedByRole_impl (CORBA::Object_ptr obj);
  ReferencedByRole_impl (CosRelationships::RelatedObject_ptr, CORBA::Long); 

};


class Reference_impl : virtual public Relationship_impl,
		       virtual public Reference::Relationship_skel
{
public:    
  Reference_impl ();
  
  Reference_impl (CORBA::Object_ptr obj);
  Reference_impl (CosRelationships::NamedRoles nr);

  virtual CORBA::Boolean _save_object ();
};


class ReferencesRoleLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


class ReferencedByRoleLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


class ReferenceLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


#endif

